#include <vxWorks.h>
#include <taskLib.h>
#include <sysLib.h>
#include <semLib.h>
#include <stdio.h>
#include <wdLib.h>

// Liczba procesow w systemie:
#define NO_OF_PROCESSES 8

// Number of Communication channels (p_balckboards):
#define NO_OF_P_BLACKBOARDS 16

// Task's enumeration definitions:
#define T_HC   0
#define T_PS   1
#define T_AS   2
#define T_AC1  3
#define T_AC2  4
#define T_AR   5
#define T_DA   6
#define T_PT   7

// p_balackboards enumaration definitions:

#define B_Up	 0
#define B_THM	 1
#define B_Upf	 2
#define B_THD	 3
#define B_qm	 4
#define B_Dhm	 5
#define B_Dhd	 6
#define B_Dhd1	 7
#define B_Dhd2	 8
#define B_MA1	 9
#define B_MA2	10
#define B_p1	11
#define B_p2	12


// Process'es atributes structure:
typedef struct process_attribute_type
{ 	char 		NAME[100];
	void*		ENTRY_POINT;
	int			STACK_SIZE;
	int			BASE_PRIORITY;
	int			PERIOD;
	int			TIME_CAPACITY;
	int 		DEADLINE;
} PROCESS_ATTRIBUTE_TYPE;

typedef struct p_blackboard_data
{
	char 	NAME[100];
	SEM_ID	MUTEX_ID;
	float	DATA;
} P_BALCKBOARD_DATA;