#include "fl_contrl_sys.h"

#define MAX_RW_READERS 10

extern P_BALCKBOARD_DATA blackboard_table[NO_OF_P_BLACKBOARDS];

P_CREATE_BLACKBOARD(int BLCAKBOARD_ID)
{
	blackboard_table[BLCAKBOARD_ID].MUTEX_ID=
		semRWCreate(SEM_Q_PRIORITY,MAX_RW_READERS);
	
	//Object creation control?
}

P_READ_BLACKBOARD(int BLCAKBOARD_ID,
				  float* MESSAGE_ADDR
				 )
{
	semRTake(blackboard_table[BLCAKBOARD_ID].MUTEX_ID,WAIT_FOREVER);
		*MESSAGE_ADDR=blackboard_table[BLCAKBOARD_ID].DATA;
	semGive(blackboard_table[BLCAKBOARD_ID].MUTEX_ID);		
}

P_DISPLAY_BLACKBOARD( int BLCAKBOARD_ID,
					  float* MESSAGE_ADDR
					)
{
	semWTake(blackboard_table[BLCAKBOARD_ID].MUTEX_ID,WAIT_FOREVER);
		blackboard_table[BLCAKBOARD_ID].DATA=*MESSAGE_ADDR;
	semGive(blackboard_table[BLCAKBOARD_ID].MUTEX_ID);		
}